/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2008 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "editor/experiment_store.h"
#include "editor/experiment.h"

using namespace Tk::Editor;

Experiment:: Experiment(Tk::Db::Database *database, const Tk::Db::Id &id)
  : Item(database, id, database->get_properties("experiment", id) )
{
}

void
Experiment:: set_property(const Tk::String &name, const Tk::Db::Data::Value &value)
{
  _database->set_property("experiment", _id, name, value);
}

Tk::String
Experiment:: get_store_cell_text()
{
  return Tk::String("Experiment #") + Tk::String(_id);
}
