/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004, 2005, 2006, 2007 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_EXP_LOCATION_SELECTOR_H__
#define __TK_EXP_LOCATION_SELECTOR_H__

#include <gtkmm.h>

#include "libtkcommon/tkstring.h"
#include "libtkdbui/data_selector_input_list.h"

namespace Tk {
  namespace Experimenter {
    
    class LocationInput : public Db::Ui::DataInput
      {
      private:
	Gtk::Entry      _name;
	Gtk::Entry      _address;
	Gtk::SpinButton _height;
      protected:
	virtual StringList get_insert_columns();
	virtual void get_values_sub(Db::PStatement &stmt);
      public:
	LocationInput(Gtk::Window &parent);
      };

    class LocationSelector : public Db::Ui::DataSelectorInputList<LocationInput>
      {
      public:
	LocationSelector(Db::Database *database, Gtk::Window *parent);
	Db::Id get_location_id() const;
      };
    
  } /* namespace Experimenter */
}; /* namespace Tk */

#endif /* __TK_EXP_LOCATION_SELECTOR_H__ */
