/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004, 2005, 2006, 2007 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_EXP_OPERATOR_SELECTOR_H__
#define __TK_EXP_OPERATOR_SELECTOR_H__

#include <gtkmm.h>

#include "libtkdbui/data_selector_input_list.h"

namespace Tk {
  namespace Experimenter {

    class OperatorInput : public Db::Ui::DataInput
      {
      private:
	Gtk::RadioButton              _male;
	Gtk::Calendar                 _date_of_birth;
	Gtk::CheckButton              _anonymous;
	Gtk::CheckButton              _send_results;
	Gtk::Entry                    _name;
	Gtk::Entry                    _place_of_birth;
	Gtk::Entry                    _email;
	Glib::RefPtr<Gtk::TextBuffer> _notes;

	void update_anonymity();
      protected:
	virtual StringList get_insert_columns();
	virtual void get_values_sub(Db::PStatement &stmt);
      public:
	OperatorInput(Gtk::Window & parent);
      };

    class OperatorSelector : public Db::Ui::DataSelectorInputList<OperatorInput>
      {
      private:
	void render_operator_cell (Gtk::CellRenderer * renderer,
				      const Gtk::TreeModel::iterator iter);
      public:
	OperatorSelector(Db::Database * database,
			    Gtk::Window * parent);
	Db::IdList get_operators();
      };
    
  } /* namespace Experimenter */
}; /* namespace Tk */

#endif /* __TK_EXP_OPERATOR_SELECTOR_H__ */
