/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_EXP_SCREEN_SIZE_H__
#define __TK_EXP_SCREEN_SIZE_H__

#include <gtkmm.h>

namespace Tk {
  namespace Experimenter {

    class ResolutionListColumns : public Gtk::TreeModel::ColumnRecord
      {
      public:
	Gtk::TreeModelColumn<unsigned> width;
	Gtk::TreeModelColumn<unsigned> height;

	ResolutionListColumns();
      };

    class ScreenSize : public Gtk::ComboBox
      {
      private:
	ResolutionListColumns _columns;
	Glib::RefPtr<Gtk::ListStore> _store;
	Gtk::CellRendererText _cell;
	
	void load_std_modes();
	void load_modes();
	bool check_and_set_active_mode(const Gtk::TreeModel::iterator& iter,
				       unsigned width,
				       unsigned height,
				       bool * set);
	bool set_active_mode(unsigned width, unsigned height);
	void set_default_mode();

	void set_cell_text (const Gtk::TreeModel::const_iterator & iter, Glib::RefPtr<Gtk::CellRendererText> cell);
      public:
	ScreenSize();
	unsigned get_width() const;
	unsigned get_height() const;
      };

  } /* namespace Experimenter */
}; /* namespace Tk */

#endif /* __TK_EXP_SCREEN_SIZE_H__ */
