/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004, 2005, 2006, 2007 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_DB_UI_DATA_SELECTOR_COMBO_H__
#define __TK_DB_UI_DATA_SELECTOR_COMBO_H__

#include <gtkmm.h>

#include "data_selector.h"

namespace Tk {
  namespace Db {
    namespace Ui {
      
      typedef Gtk::CellLayout::SlotCellData SlotComboCellData;
      typedef DisplayColumnInfo<SlotComboCellData> ComboColumnInfo;
      typedef std::list<ComboColumnInfo> ComboColumnList;
      typedef DisplayColumnAdaptor<Gtk::CellLayout> ComboColumnAdaptor;
      
      class DataSelectorCombo : public DataSelector, public Gtk::ComboBox
	{
	private:
	  void create_widgets(const ComboColumnList & display_columns);
	  
	protected:
	  
	  DataSelectorCombo(Db::Database * database,
			    const String & table_name,
			    const StringList & selection_columns);
	  // should be called immediately after constructor
	  void set_display_columns(const ComboColumnList & display_columns);
	  
	  virtual ModelIteratorList get_selected() const;
	  virtual void refreshed();
	  virtual void select(Gtk::TreeModel::iterator &iter);
	};
      
    } /* namespace Ui */
  } /* namespace Db */
}; /* namespace Tk */




#endif /* __TK_DB_UI_DATA_SELECTOR_COMBO_H__ */
