/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004, 2005, 2006, 2007 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_DB_UI_DATA_SELECTOR_INPUT_LIST_H__
#define __TK_DB_UI_DATA_SELECTOR_INPUT_LIST_H__

#include <gtkmm.h>

#include "data_selector_list.h"

namespace Tk {
  namespace Db {
    namespace Ui {

      class DataInput : public Gtk::Dialog
	{
	protected:
	  DataInput(const Glib::ustring & title, Gtk::Window & parent);
	  virtual void get_values_sub(Db::PStatement &stmt) = 0;
	public:
	  virtual StringList get_insert_columns() = 0;
	  bool get_values(Db::PStatement &stmt);
	};
      
      template<typename DI> class DataSelectorInputList : public DataSelectorList
	{
	private:
	  Gtk::Window *_parent;
	  void input();
	protected:
	  
	  DataSelectorInputList(Db::Database *database,
				const String &table,
				const StringList &selection_columns,
				Gtk::Window *parent,
				const String &title);
	  
	  virtual void refreshed();
	};

      #include "data_selector_input_list_impl.h"
      
    } /* namespace Ui */
  } /* namespace Db */
}; /* namespace Tk */




#endif /* __TK_DB_UI_DATA_SELECTOR_INPUT_LIST_H__ */
