/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2008 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_IDENTIFIER_H__
#define __TK_IDENTIFIER_H__

#include "libtkcommon/tkstring.h"

#include "libtkquery/tkquery-parser.h"
#include "libtkquery/expression.h"

namespace Tk {
  namespace Query {
    
    typedef yy::parser::location_type Location;
    
    class Identifier : public Value
      {
      private:
	Tk::String _domain;
	Location  *_domain_loc;
	Tk::String _property_name;
	Location   _property_loc;
	
	static Tk::String resolve_domain(const Location &loc, const Tk::String &partial);
      public:
	Identifier(Alpha *alpha1, const Location &alpha1_loc, Alpha *alpha2, const Location &alpha2_loc);
	Identifier(Alpha *alpha, const Location &alpha_loc, Name *name, const Location &name_loc);
	Identifier(Name *name, const Location &name_loc);
	Identifier(Alpha *alpha, const Location &alpha_loc);
	~Identifier();
	virtual Query * build_query(Tk::Db::Database *database, const Tk::String &domain) const;
      };
    
  }; /* namespace Query */
}; /* namespace Tk */

#endif /* __TK_IDENTIFIER_H__ */
