/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "random_types.h"

using namespace Tk;
using namespace Random;

BitIStream *
Bits:: get_data () const
{
  std::basic_ostringstream<BitChar> data;

  unsigned bit_count = size();

  unsigned char_index(0);
  BitChar c(0);
  for (const_iterator iter = begin();
       iter != end();
       ++iter)
    {
      c |= *iter << (BITS_PER_CHAR - char_index);

      ++char_index;
      if (char_index == BITS_PER_CHAR)
	{
	  data << c;
	  char_index = 0;
	}
    }
  
  if (char_index != 0)
    data << c;
  
  return new BitIStream(data.str());
}

Bits::size_type
Bits:: get_data_len() const
{
  size_type bit_count( size() );
  return (bit_count / BITS_PER_CHAR) + ((bit_count % BITS_PER_CHAR > 1) ? 1 : 0);
}
